using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Suppliers;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface ISupplierRepository
    {
        Task<BaseResult> Add(SupplierElastic Supplier);
        Task<BaseResult> AddManyAsync(IEnumerable<SupplierElastic> Suppliers);
        Task<SmartTableResult<SupplierElastic>> Search(BoolQueryDescriptor<SupplierElastic> query);

    }
    public class SupplierRepository : ISupplierRepository
    {
        private readonly ElasticIndex<SupplierElastic> _dbContext;

        public SupplierRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<SupplierElastic>(settings.Value.ClusterUrl, "inventorysupplier");
        }


        public async Task<SmartTableResult<SupplierElastic>> Search(BoolQueryDescriptor<SupplierElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(SupplierElastic Supplier)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Supplier);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<SupplierElastic> Suppliers)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Suppliers);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

    }
}
